/*****************************************
motor_1.java
 
Motor de busqueda dentro del rango del ITM
desde 200.33.171.1 a 200.33.171.254
(configurado solo para buscar en 200.33.171.7)

Requiere desempaquetar el archivo del conector
mysql-connector-java-5.1.8-bin.jar
y genera los directorios
com
META-INF
org
que deben estar en el mismo directorio que este codigo

Requiere crear una base de datos y una tabla en MySQL
por lo que se anexa el archivo:
motor.sql
que es el archivo que se debe importar para crear
la base y tabla
 
octubre 2009 -  Rogelio Ferreira Escutia
*****************************************/

import java.net.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class motor_1 {

	Connection con = null;
	Statement stmt = null;

	public static void main (String[] args) throws IOException {
		Connection db;
		System.out.println("\n---------- Arrancando Motor de Busqueda ----------\n");
		motor_1 objeto = new motor_1();
		objeto.conectar();
	}

	public void conectar() throws IOException {
		String cadena_a_buscar="", dirIp="", xUrl="", peticion="", informacion="", almacenar="";
		int i, leido, indice=0;
		Socket conexion   = null;
		DataInputStream entrada = null;
		DataOutputStream salida = null;
		byte datosBytes[] = new byte[256];
		abrir_base();
		InputStreamReader activar_buffer = new InputStreamReader(System.in);
		BufferedReader capturar = new BufferedReader(activar_buffer);
		System.out.print("\nEscribe el dato a buscar?: ");
		cadena_a_buscar = capturar.readLine();
		System.out.println("\nBuscando cadena='"+cadena_a_buscar+"'\n");
		for (i=7; i<8; i++) {
			//dirIp ="127.0.0."; Para busquedas locales
	   	dirIp ="200.33.171.";
			dirIp = dirIp.concat(String.valueOf(i));
			try {
				System.out.print("Intentando: " + dirIp);
				conexion=new Socket (InetAddress.getByName (dirIp), 80);
				System.out.print(" CONECTADO !!!");
				xUrl = NombreDelHost(dirIp);
				System.out.print(" URL: "+xUrl);
				peticion="GET /index.html HTTP/1.1\n";
				peticion+="Accept: */*\n";
				peticion+="Accept-Language: es\n";
				peticion+="Accept-Encoding: gzip, deflate\n";
				peticion+="User-Agent: Mozilla/4.0 (compatible; MSIE 5.01;    Windows NT)\n";
				peticion+="Host: 127.0.0.1\n";
				peticion+="Connection: Keep-Alive\n\n";
				salida=new DataOutputStream(conexion.getOutputStream());
				salida.write(peticion.getBytes());
				entrada=new DataInputStream(conexion.getInputStream());
				try {
					while ((leido=entrada.read(datosBytes,0,256))>0) {
						if (leido>0) {
							informacion = new String(datosBytes,0,(leido-1));
							System.out.println (informacion);
							indice = informacion.indexOf(cadena_a_buscar);
							if(indice!=-1) {
								System.out.println("SE ENCONTRO");
								almacenar = informacion.substring(indice-10, indice + cadena_a_buscar.length()+10 );
								grabar_base(cadena_a_buscar, dirIp, almacenar);
							}
						}
					}
				} catch (EOFException e) { }
				System.out.println("\n\n---------- CERRANDO CONEXION ----------\n");
				conexion.close();
				System.out.println("indice: "+indice);
			} catch (IOException e) { System.out.println(" " + e.toString() + " Error al conectar !!!"); }	
		}
		cerrar_base();
	}

	public static String NombreDelHost(String ip) throws UnknownHostException {
		InetAddress addres = InetAddress.getByName(ip);
		return addres.getHostName();
	}

	public void abrir_base() {
		System.out.println("\nAbriendo base de datos");
		try { Class.forName("com.mysql.jdbc.Driver"); } catch(java.lang.ClassNotFoundException err) { System.out.println("Clase no encontrada: " + err); }
		try {
			con = DriverManager.getConnection("jdbc:mysql://localhost/motor", "root","");
			stmt = con.createStatement();
		} catch(java.sql.SQLException error) { System.out.println("Se produjo error: "+error); }
	}

	public void grabar_base(String cadena, String direccion, String contenido) {
		System.out.println("\ngrabando base de datos");
		System.out.println("\nDatos: "+cadena + " "+direccion+" "+contenido);
		try {
			String sentenciaSQL = "INSERT INTO indexados VALUES('"+cadena+"','"+direccion+"','"+contenido+"')";
			stmt.executeUpdate(sentenciaSQL);
		} catch( Exception e ) { System.out.println( e.getMessage() ); }
	}

	public void cerrar_base() {
		System.out.println("\nCerrando base de datos");
		try {
			con.close();
			stmt.close();
		} catch( Exception e ) { System.out.println( e.getMessage() ); }
	}

}
